

#[derive(Debug)]
enum IpAddrKind{
    V4(u8,u8,u8,u8),
    V6(String),
}

#[derive(Debug)]
struct IpAddr {
    kind: IpAddrKind,
}

#[derive(Debug)]
enum Message{
    Quit,
    Move{x:i32,y:i32},
    Write(String),
    ChangeColor{red:i32,blue:i32,green:i32},
}

impl Message {
    fn call(&self){

        println!("RUNNING CALL {:#?}",&self);
    }
}

#[derive(Debug)]
enum UsState {
    Alabama,
    Alaska,
}


enum Coin {
    Penny,
    Nickel,
    Dime,
    Quater(UsState),
}

fn value_in_cents(coin:Coin) -> u8 {
    match coin {
        Coin::Penny => {
            println!("Lucky Penny");
            1
        },
        Coin::Nickel => {
            println!("Lucky Nickel");
            5
        },
        Coin::Dime => {
            println!("Lucky Dime");
            10
        },
        Coin::Quater(_state) => {
            println!("State quater from {:?}!", _state);
            25
        },
    }
}

fn plus_one(x:Option<i32>) -> Option<i32>{
    match x {
        None => None,
        Some(i) => Some(i + 1),
    }
}


fn main() {
    let home = IpAddr{
        kind: IpAddrKind::V4(127,0,0,1),
    };

    let loopback = IpAddr{
        kind: IpAddrKind::V6(String::from("::1")),
    };

    let example_msg = Message::ChangeColor{
        red: 255,
        blue: 255,
        green: 255,
    };

    example_msg.call();

    let m = Message::Write(String::from("hello World"));
    m.call();

    let some_number = Some(5);
    let some_string = Some("darwin subramaniam");

    let x:i8 = 5;
    let y: Option<i8> = Some(5);

    let penny = Coin::Quater(UsState::Alabama);
    println!("Value of coin {}",value_in_cents(penny));

    let five = Some(5);
    let six = plus_one(five);
    assert_eq!(six.is_some(),true);

    let none = plus_one(None);
    println!("{:?}",none );
    assert_eq!(none.is_some(), false);

    // Example on exhaustive patterns.
    match six {
        Some(6) => println!("{}",6),
        _ => println!("No matching"),
    };


    let some_u8_value = 1u8;
    match  some_u8_value {
        1 => println!("one"),
        3 => println!("Three"),
        5 => println!("Five"),
        _ => println!("NONE"),
    }

    let some_u8_value = Some(0u8);

    if let Some(1) =some_u8_value{
        println!("ZERO")
    }else{
        println!("NON WANTED");
    }

}

fn route(ip_kind: IpAddrKind){
    println!();
    println!("{:?}", ip_kind);
}
